import pandas as pd
import logging
from datetime import date
import lxml.etree as et
import numpy as np
import time
from utils import WAREHOUSE

today = date.today()
today = today.strftime("%d_%m_%Y")

logging.basicConfig(filename=("logs/CDON_" + today +".log"), level=logging.INFO, format='%(asctime)s %(levelname)s:%(message)s', datefmt='%Y-%m-%d %H:%M:%S')


def readOldXML(file, products):
    entries = []
    for prod in products.itertuples():
        entry = {
            'id': 'None',
            'se': {
                'salePrice': '0',
                'originalPrice': '0',
                'shippingCost': '0',
                'vat': '25',
                #'isShippedFromEU': 'True',
            },
            }
        """'dk': {
                'salePrice': '0',
                'originalPrice': '0',
                'shippingCost': '0',
                'vat': '25',
                #'isShippedFromEU': 'True',
            },
            'fi': {
                'salePrice': '0',
                'originalPrice': '0',
                'shippingCost': '0',
                'vat': '25.5',
                #'isShippedFromEU': 'True',
            },
        }"""
        entry['id'] = getattr(prod, 'sku')

        entry['se']['salePrice'] = getattr(prod, 'price')
        entry['se']['originalPrice'] = getattr(prod, 'price')
        entry['se']['shippingCost'] = getattr(prod, 'shippingCostSE')
        
        """entry['dk']['salePrice'] = getattr(prod, 'price_dk')
        entry['dk']['originalPrice'] = getattr(prod, 'price_dk')
        entry['dk']['shippingCost'] = getattr(prod, 'shippingCostDK')
        
        entry['fi']['salePrice'] = getattr(prod, 'price_fi')
        entry['fi']['originalPrice'] = getattr(prod, 'price_fi')
        entry['fi']['shippingCost'] = getattr(prod, 'shippingCostFI')"""
        
        entries.append(entry)
    save(entries, file)
    
def save(entries, file):
    flag = True
    start_time = time.time()
    marketplace = et.Element("marketplace", xmlns = "https://schemas.cdon.com/product/4.0/4.9.0/price")
    counter = 0
    print(len(entries))
    for entry in entries:
        print(f"{counter}/{len(entries)}", end = '\r')
        if counter%10000 == 0:
            print(time.time()-start_time)
            start_time = time.time()
        counter += 1
        product = et.SubElement(marketplace, "product")
        id = et.SubElement(product, 'id')
        id.text = str(entry['id'])
        se = et.SubElement(product, "se")
        se_salePrice = et.SubElement(se, "salePrice")
        se_salePrice.text = str(entry["se"]['salePrice'])
        se_originalPrice = et.SubElement(se, "originalPrice")
        se_originalPrice.text = str(entry["se"]['originalPrice'])
        se_shippingCost = et.SubElement(se, "shippingCost")
        se_shippingCost.text = str(entry["se"]['shippingCost'])
        se_vat = et.SubElement(se, "vat")
        se_vat.text = str(entry["se"]['vat'])
        #se_isShippedFromEU = et.SubElement(se, "isShippedFromEU")
        #se_isShippedFromEU.text = str(entry["se"]['isShippedFromEU'])
        """dk = et.SubElement(product, "dk")
        dk_salePrice = et.SubElement(dk, "salePrice")
        dk_salePrice.text = str(entry["dk"]['salePrice'])
        dk_originalPrice = et.SubElement(dk, "originalPrice")
        dk_originalPrice.text = str(entry["dk"]['originalPrice'])
        dk_shippingCost = et.SubElement(dk, "shippingCost")
        dk_shippingCost.text = str(entry["dk"]['shippingCost'])
        dk_vat = et.SubElement(dk, "vat")
        dk_vat.text = str(entry["dk"]['vat'])
        #dk_isShippedFromEU = et.SubElement(dk, "isShippedFromEU")
        #dk_isShippedFromEU.text = str(entry["dk"]['isShippedFromEU'])
        fi = et.SubElement(product, "fi")
        fi_salePrice = et.SubElement(fi, "salePrice")
        fi_salePrice.text = str(entry["fi"]['salePrice'])
        fi_originalPrice = et.SubElement(fi, "originalPrice")
        fi_originalPrice.text = str(entry["fi"]['originalPrice'])
        fi_shippingCost = et.SubElement(fi, "shippingCost")
        fi_shippingCost.text = str(entry["fi"]['shippingCost'])
        fi_vat = et.SubElement(fi, "vat")
        fi_vat.text = str(entry["fi"]['vat'])
        #fi_isShippedFromEU = et.SubElement(fi, "isShippedFromEU")
        #fi_isShippedFromEU.text = str(entry["fi"]['isShippedFromEU'])"""
    new = et.ElementTree(marketplace)
    with open(file, "wb") as fh:
        new.write(fh, xml_declaration=True, method="xml", encoding='utf-8', pretty_print = True)
    print('prices saved ' + file)

def execute():
    products = pd.read_csv('download/'+WAREHOUSE['warehouse']+'_se.csv', sep=';')
    cdon_ids = pd.read_csv('download/cdon_ids.csv', sep=';')
    joined_products = pd.merge(cdon_ids, products, left_on = 'sku', right_on = 'sku', how='left')
    print(joined_products.shape[0])
    joined_products.replace(np.nan, 5000, inplace=True)
    readOldXML(f'feeds/prices.xml', joined_products)
    
            
if __name__ == "__main__":
    execute()
